package com.zt.plat.module.base.service.materialhasclasses;

import cn.hutool.core.collection.CollUtil;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import com.zt.plat.module.base.controller.admin.materialhasclasses.vo.*;
import com.zt.plat.module.base.dal.dataobject.materialhasclasses.MaterialHasClassesDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.pojo.PageParam;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.base.dal.dao.materialhasclasses.MaterialHasClassesMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.diffList;
import static com.zt.plat.module.base.enums.ErrorCodeConstants.*;

/**
 * 物料持有分类 Service 实现类
 *
 * @author 后台管理-1
 */
@Service
@Validated
public class MaterialHasClassesServiceImpl implements MaterialHasClassesService {

    @Resource
    private MaterialHasClassesMapper materialHasClassesMapper;

    @Override
    public MaterialHasClassesRespVO createMaterialHasClasses(MaterialHasClassesSaveReqVO createReqVO) {
        // 插入
        MaterialHasClassesDO materialHasClasses = BeanUtils.toBean(createReqVO, MaterialHasClassesDO.class);
        materialHasClassesMapper.insert(materialHasClasses);
        // 返回
        return BeanUtils.toBean(materialHasClasses, MaterialHasClassesRespVO.class);
    }

    @Override
    public void updateMaterialHasClasses(MaterialHasClassesSaveReqVO updateReqVO) {
        // 校验存在
        validateMaterialHasClassesExists(updateReqVO.getId());
        // 更新
        MaterialHasClassesDO updateObj = BeanUtils.toBean(updateReqVO, MaterialHasClassesDO.class);
        materialHasClassesMapper.updateById(updateObj);
    }

    @Override
    public void deleteMaterialHasClasses(Long id) {
        // 校验存在
        validateMaterialHasClassesExists(id);
        // 删除
        materialHasClassesMapper.deleteById(id);
    }

    @Override
        public void deleteMaterialHasClassesListByIds(List<Long> ids) {
        // 校验存在
        validateMaterialHasClassesExists(ids);
        // 删除
        materialHasClassesMapper.deleteByIds(ids);
        }

    private void validateMaterialHasClassesExists(List<Long> ids) {
        List<MaterialHasClassesDO> list = materialHasClassesMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(MATERIAL_HAS_CLASSES_NOT_EXISTS);
        }
    }

    private void validateMaterialHasClassesExists(Long id) {
        if (materialHasClassesMapper.selectById(id) == null) {
            throw exception(MATERIAL_HAS_CLASSES_NOT_EXISTS);
        }
    }

    @Override
    public MaterialHasClassesDO getMaterialHasClasses(Long id) {
        return materialHasClassesMapper.selectById(id);
    }

    @Override
    public PageResult<MaterialHasClassesDO> getMaterialHasClassesPage(MaterialHasClassesPageReqVO pageReqVO) {
        return materialHasClassesMapper.selectPage(pageReqVO);
    }

}